#!/usr/bin/env python3
import collections
import subprocess


if __name__ == "__main__":
    to_exec = [
        "perf",
        "stat",
        "-x", ",",
        '-e', 'cache-misses',
        '-e', 'cache-references',
        '-e', 'instructions',
        '-A',
        '-I', '100',
    ]

    last_t = None
    per_core = collections.defaultdict(dict)

    p = subprocess.Popen(to_exec, stderr=subprocess.PIPE)
    while True:
        line = p.stderr.readline()
        if not line:
            break

        t, cpu, value, _, name, _, _, _, _ = line.strip().split(b',')

        if t != last_t:
            for core, counters in per_core.items():
                cmr = counters[b'cache-misses'] / counters[b'cache-references']
                if cmr > 0.85:
                    core = core.decode('ascii')
                    print(f"ALERT on {core}")

            last_t = t
            per_core = collections.defaultdict(dict)

        per_core[cpu][name] = int(value)
